on prepChooser
  global gLangSelect, gLangDirect, gWdTag, gPhsTag, gScorePermit, gScorePeep
  cursor(4)
  go("chooser")
  doMusicBtn()
  unloadMember()
  if gLangDirect <> 1 then
    set the memberNum of sprite gWdTag to the number of member (gLangSelect & " wordstitle")
    set the memberNum of sprite gPhsTag to the number of member (gLangSelect & " phrasestitle")
  else
    set the memberNum of sprite gWdTag to the number of member "e wordstitle"
    set the memberNum of sprite gPhsTag to the number of member "e phrasestitle"
  end if
  if gScorePermit <> 1 then
    set the memberNum of sprite gScorePeep to the number of member "score gray"
  end if
  updateStage()
  cursor(-1)
end

on prepTracking
  global gLangSelect, gLangDirect
  cursor(4)
  go("quit")
  unloadMember()
  if gLangDirect <> 1 then
    set the memberNum of sprite 1 to the number of member (gLangSelect & " tracking")
    set the memberNum of sprite 2 to the number of member (gLangSelect & " save")
    set the memberNum of sprite 3 to the number of member (gLangSelect & " exit")
    set the memberNum of sprite 4 to the number of member (gLangSelect & " print")
  else
    set the memberNum of sprite 1 to the number of member "e tracking"
    set the memberNum of sprite 2 to the number of member "e save"
    set the memberNum of sprite 3 to the number of member "e exit"
    set the memberNum of sprite 4 to the number of member "e print"
  end if
  cursor(-1)
end

on leaveScreen whichScreen
  global gCurrSndList, gCurrAnimaList, gBridgeParts
  cursor(4)
  sound stop 1
  if gCurrSndList <> [] then
    clearSndList()
  end if
  if gCurrAnimaList <> [] then
    clearAnimalist()
  end if
  case whichScreen of
    "quiz":
      TrackChangeGame()
      prepChooser()
    "race":
      sound stop 1
      sound stop 2
      TrackChangeGame()
      prepChooser()
    "chooser":
      popUp("quit", "y/n")
    "score":
      prepChooser()
    "bridge":
      if gBridgeParts = 10 then
        TrackChangeGame()
        prepChooser()
      else
        returnFromBridgeToQuiz()
      end if
    "gallery":
      prepChooser()
      leaveGallery()
    "fullPaint":
      prepGallery()
    "find":
      put EMPTY into field "possWords"
      put EMPTY into field "wordFound"
      put EMPTY into field "wordFind"
      prepChooser()
  end case
  unloadMember(member "fart1", "click13")
  unloadMember()
  cursor(-1)
end

on goToHighScoreScreen btnOrExit
  global gBootyHome, gCoverSprite, gCoverTimer, gCurrInit, gFstPopInit, gLangSelect, gLangDirect, gTypeTag, gLstPopSpt, gBackBtn, gScoreTitle, gFirstPopSpt, gPopped
  cursor(4)
  set the visible of sprite gCoverSprite to 1
  set gPopped to 1
  sound stop 1
  updateStage()
  go("score")
  doMusicBtn()
  if gLangDirect <> 1 then
    set the memberNum of sprite gFirstPopSpt to the number of member (gLangSelect & " keyboard")
    set the memberNum of sprite gScoreTitle to the number of member (gLangSelect & " typeTag")
  else
    set the memberNum of sprite gScoreTitle to the number of member "e typeTag"
    set the memberNum of sprite gFirstPopSpt to the number of member "e keyboard"
  end if
  case btnOrExit of
    "0":
      clearTypeWriter(btnOrExit)
    "1":
      set the memberNum of sprite gBackBtn to the number of member "quit gray"
      set shouldIUpdate to 0
      set shouldIUpdate to compareHighScores()
      if shouldIUpdate <> 1 then
        clearTypeWriter("0")
      else
        set gCurrInit to gFstPopInit
        set gThisName to EMPTY
      end if
  end case
  updateStage()
  cursor(-1)
  set the visible of sprite gCoverSprite to 0
end

on clearTypeWriter whichWay
  global gPopUp, gFirstPopSpt, gLstPopSpt, gFstPopInit, gLstPopInit, gThisName, gWhichPop, gTypeTag, gBackBtn, gPopped
  case whichWay of
    "1":
      Update_High_Score(gThisName)
      saveHighScore()
    "0":
  end case
  prepHighScoreScreen()
  updateStage()
  repeat with X = gFirstPopSpt to gTypeTag
    set the locH of sprite X to the locH of sprite X - 672
  end repeat
  set foo to the name of member the memberNum of sprite gBackBtn of castLib "shared"
  put "up" into word 2 of foo
  set the memberNum of sprite gBackBtn to the number of member foo of castLib "shared"
  set gPopped to 0
end

on viewBridge
  clearSndList()
  clearAnimalist()
  prepBridge()
end

on prepBridge
  global gBridgeParts, gWhichBridge, gBear, gPopBox, gPopped, gLangSelect, gLangDirect, gBackBtn
  cursor(4)
  sound stop 1
  go("bridge")
  set the memberNum of sprite 1 to the number of member (gWhichBridge & " bridge " & gBridgeParts + 1)
  case gBridgeParts of
    "0":
      set h to 90
      set v to 0
    "1":
      set h to 150
      set v to 0
    "2":
      set h to 365
      set v to 0
    "3":
      set h to 520
      set v to 0
    "4":
      set h to 520
      set v to 160
    "5":
      set h to 320
      set v to 160
    "6":
      set h to 200
      set v to 160
    "7":
      set h to 104
      set v to 160
    "8":
      set h to 300
      set v to 240
    "9":
      set h to 540
      set v to 240
    "10":
      set h to 320
      set v to 200
      set popH to 320
      set popV to 85
      if gLangDirect = 1 then
        set the memberNum of sprite gPopBox to the number of member "e drive sign"
      else
        set the memberNum of sprite gPopBox to the number of member (gLangSelect & " drive sign")
      end if
      updateStage()
      set the loc of sprite gPopBox to point(popH, popV)
      set the loc of sprite (gPopBox + 1) to point(popH - 163, popV + 28)
      set the loc of sprite (gPopBox + 2) to point(popH + 174, popV + 27)
      set gPopped to 1
      set the memberNum of sprite gBackBtn to the number of member "back gray"
  end case
  set the loc of sprite gBear to point(h, v)
  cursor(-1)
end

on returnFromBridgeToQuiz
  global gBridgeMonitor, gBridgeParts, gQuestion, gStampSpt, gAnswerLst, gClickNote, gAnswered
  cursor(4)
  sound stop 1
  go("quiz")
  doMusicBtn()
  set the memberNum of sprite gBridgeMonitor to the number of member ("bridge " & gBridgeParts)
  set text to gQuestion
  set letterLst to []
  setboxSize("questBox")
  set letterLst to countAndCenterText(text, "whi", "center")
  stampOutTxt(letterLst, gStampSpt, "1")
  repeat with X = 1 to 4
    set text to getAt(gAnswerLst, X)
    set letterLst to []
    setboxSize("ans" & X)
    set letterLst to countAndCenterText(text, "whi", "center")
    stampOutTxt(letterLst, gStampSpt, "1")
  end repeat
  if gAnswered = 1 then
    set the memberNum of sprite gClickNote to the number of member "click up"
  end if
  cursor(-1)
end

on prepGallery
  global gFullPaint, gBridgeLst, gFstBridgePic, gGalleryText, gLangDirect, gLangSelect
  puppetSprite(gFullPaint, 1)
  set the visible of sprite gFullPaint to 0
  sound stop 1
  go("gallery")
  if count(gBridgeLst) <> 0 then
    sort(gBridgeLst)
    repeat with X = 1 to count(gBridgeLst)
      set whichBridge to getAt(gBridgeLst, X)
      set whichSprite to gFstBridgePic + value(whichBridge) - 1
      set the memberNum of sprite whichSprite to the number of member ("painting " & whichBridge & " up")
    end repeat
    if gLangDirect = 1 then
      set the memberNum of sprite gGalleryText to the number of member "e galleryword 2"
    else
      set the memberNum of sprite gGalleryText to the number of member (gLangSelect & " galleryword 1")
    end if
  else
    if gLangDirect = 1 then
      set the memberNum of sprite gGalleryText to the number of member "e galleryword 2"
    else
      set the memberNum of sprite gGalleryText to the number of member (gLangSelect & " galleryword 2")
    end if
  end if
end

on leaveFullPaint
  global gFullPaint
end

on leaveGallery
  global gFullPaint
end

on viewPainting whichBtn
  global gFullPaint
  sound stop 1
  puppetSprite(gFullPaint, 1)
  set the visible of sprite gFullPaint to 0
  set foo to the name of member the memberNum of sprite whichBtn of castLib "gallery"
  put "close" into word 3 of foo
  go("fullPaint")
  set the memberNum of sprite gFullPaint to the number of member foo
  updateStage()
  set the visible of sprite gFullPaint to 1
  puppetSprite(gFullPaint, 0)
end

on prepCloser
  global gLangDirect, gLangSelect
  cursor(4)
  go("closer")
  if gLangDirect = 1 then
    set the memberNum of sprite 1 to the number of member ("e " & gLangSelect & " credits")
  else
    set the memberNum of sprite 1 to the number of member (gLangSelect & " e credits")
  end if
  updateStage()
  cursor(-1)
end
