on StampTrackingAtBegining
  global gLangSelect, gLangDirect
  if gLangDirect = 1 then
    set title to "PAINTER BEAR'S LANGUAGE BRIDGE"
  else
    case gLangSelect of
      "g":
        set title to "Maler Bärs Sprachenbrücke"
      "s":
        set title to "PUENTE DE IDIOMAS DEL OSO PINTOR"
      "f":
        set title to "LE PONT DE LANGUES D'OURS-LE-PEINTRE"
      "i":
        set title to "PONTE DI LINGUAGGIO DEL PITTORE ORSO"
    end case
  end if
  put EMPTY into field "trackingfield"
  put "*************************************************" into field "trackingfield"
  put RETURN & "* " & title & " *" after field "trackingfield"
  put RETURN & "*************************************************" after field "trackingfield"
end

on InitializeTracking whichGame
  global gGameName, gTimeBegan, gTotalAttempts, gNumCorrect, gNumWrong, gWhichGame, gLevel, gLangSelect, gLangDirect
  if gLangDirect = 1 then
    set catTitle to "Category"
    set dateTitle to "date"
  else
    case gLangSelect of
      "g":
        set catTitle to "Kategorie"
        set dateTitle to "Datum"
      "s":
        set catTitle to "Categoría"
        set dateTitle to "Fecha"
      "f":
        set catTitle to "Catégorie"
        set dateTitle to "Date"
      "i":
        set catTitle to "Categoria"
        set dateTitle to "Data"
    end case
  end if
  set gWhichGame to whichGame
  CallGamesByName()
  set gTotalAttempts to 0
  set gNumCorrect to 0
  set gNumWrong to 0
  set gTimeBegan to the short time
  put EMPTY after field "trackingfield"
  put RETURN & "================================================================" after field "trackingfield"
  put RETURN & catTitle & ":" && gGameName after field "trackingfield"
  put RETURN & dateTitle && the short date after field "trackingfield"
  put RETURN & "----------------------------------------------------------------" after field "trackingfield"
end

on CallGamesByName
  global gWhichGame, gGameName, gLangSelect, gLangDirect
  if gLangDirect = 1 then
    case gWhichGame of
      "colr":
        set gGameName to "Colors"
      "tran":
        set gGameName to "Transportation"
      "clth":
        set gGameName to "Clothing"
      "rltv":
        set gGameName to "People"
      "stor":
        set gGameName to "Stores"
      "buil":
        set gGameName to "Buildings"
      "body":
        set gGameName to "The Body"
      "spor":
        set gGameName to "Sports and Hobbies"
      "occp":
        set gGameName to "Occupations"
      "numb":
        set gGameName to "Numbers"
      "schl":
        set gGameName to "School"
      "dirc":
        set gGameName to "Directions"
      "bath":
        set gGameName to "The Bathroom"
      "kitc":
        set gGameName to "The Kitchen"
      "time":
        set gGameName to "Time"
      "geog":
        set gGameName to "Geography"
      "city":
        set gGameName to "The City"
      "hous":
        set gGameName to "The House"
      "furn":
        set gGameName to "Furniture"
      "weat":
        set gGameName to "Weather"
      "conj":
        set gGameName to "Miscellaneous"
      "anml":
        set gGameName to "Animals"
      "food":
        set gGameName to "Food"
      "advb":
        set gGameName to "Adverbs"
      "verb":
        set gGameName to "Verbs"
      "adjv":
        set gGameName to "Adjectives"
      "trvl":
        set gGameName to "Travel"
      "tphr":
        set gGameName to "Travel Phrases"
      "mphr":
        set gGameName to "Other Helpful Phrases"
      "all":
        set gGameName to "Everything!"
      "allw":
        set gGameName to "All words"
    end case
  else
    case gLangSelect of
      "g":
        case gWhichGame of
          "colr":
            set gGameName to "Farben"
          "tran":
            set gGameName to "Beförderungsmittel"
          "clth":
            set gGameName to "Bekleidung"
          "rltv":
            set gGameName to "Menschen"
          "stor":
            set gGameName to "Geschäfte"
          "buil":
            set gGameName to "Gebäude"
          "body":
            set gGameName to "Der Körper"
          "spor":
            set gGameName to "Sport und Hobbys"
          "occp":
            set gGameName to "Berufe"
          "numb":
            set gGameName to "Nummern"
          "schl":
            set gGameName to "Schule"
          "dirc":
            set gGameName to "Richtungen"
          "bath":
            set gGameName to "Das Badezimmer"
          "kitc":
            set gGameName to "Die Küche"
          "time":
            set gGameName to "Uhrzeit"
          "geog":
            set gGameName to "Erdkunde"
          "city":
            set gGameName to "Die Stadt"
          "hous":
            set gGameName to "Das Haus"
          "furn":
            set gGameName to "Möbel"
          "weat":
            set gGameName to "Wetter"
          "conj":
            set gGameName to "Verschiedenes"
          "anml":
            set gGameName to "Tiere"
          "food":
            set gGameName to "Lebensmittel"
          "advb":
            set gGameName to "Adverben"
          "verb":
            set gGameName to "Verben"
          "adjv":
            set gGameName to "Adjektive"
          "trvl":
            set gGameName to "Reise"
          "tphr":
            set gGameName to "Reise-Redewendungen"
          "mphr":
            set gGameName to "Andere nützliche Redewendungen"
          "all":
            set gGameName to "Alles!"
          "allw":
            set gGameName to "Alle Wörter"
        end case
      "s":
        case gWhichGame of
          "colr":
            set gGameName to "Colores"
          "tran":
            set gGameName to "Transporte"
          "clth":
            set gGameName to "Ropas"
          "rltv":
            set gGameName to "Gente"
          "stor":
            set gGameName to "Tiendas"
          "buil":
            set gGameName to "Edificios"
          "body":
            set gGameName to "El cuerpo"
          "spor":
            set gGameName to "Deportes y pasatiempos"
          "occp":
            set gGameName to "Ocupaciones"
          "numb":
            set gGameName to "Números"
          "schl":
            set gGameName to "Escuela"
          "dirc":
            set gGameName to "Direcciones"
          "bath":
            set gGameName to "El baño"
          "kitc":
            set gGameName to "La cocina"
          "time":
            set gGameName to "Tiempo"
          "geog":
            set gGameName to "Geografía"
          "city":
            set gGameName to "La ciudad"
          "hous":
            set gGameName to "La casa"
          "furn":
            set gGameName to "Mobiliario"
          "weat":
            set gGameName to "El tiempo"
          "conj":
            set gGameName to "Miscelánea"
          "anml":
            set gGameName to "Animales"
          "food":
            set gGameName to "Comida"
          "advb":
            set gGameName to "Adverbios"
          "verb":
            set gGameName to "Verbos"
          "adjv":
            set gGameName to "Adjetivos"
          "trvl":
            set gGameName to "Viajar"
          "tphr":
            set gGameName to "Frases para viajar"
          "mphr":
            set gGameName to "Otras expresiones útiles"
          "all":
            set gGameName to "¡Todo!"
          "allw":
            set gGameName to "Todas las palabras"
        end case
      "f":
        case gWhichGame of
          "colr":
            set gGameName to "Couleurs"
          "tran":
            set gGameName to "Moyens de transport"
          "clth":
            set gGameName to "Vêtements"
          "rltv":
            set gGameName to "Gens"
          "stor":
            set gGameName to "Magasins"
          "buil":
            set gGameName to "Bâtiments"
          "body":
            set gGameName to "Le corps"
          "spor":
            set gGameName to "Sports et passe-temps"
          "occp":
            set gGameName to "Professions"
          "numb":
            set gGameName to "Nombres"
          "schl":
            set gGameName to "L'école"
          "dirc":
            set gGameName to "Directions"
          "bath":
            set gGameName to "La salle de bains"
          "kitc":
            set gGameName to "La cuisine"
          "time":
            set gGameName to "L'heure"
          "geog":
            set gGameName to "La géographie"
          "city":
            set gGameName to "La ville"
          "hous":
            set gGameName to "La maison"
          "furn":
            set gGameName to "Les meubles"
          "weat":
            set gGameName to "Le temps"
          "conj":
            set gGameName to "Divers"
          "anml":
            set gGameName to "Les animaux"
          "food":
            set gGameName to "La nourriture"
          "advb":
            set gGameName to "Les adverbes"
          "verb":
            set gGameName to "Les verbes"
          "adjv":
            set gGameName to "Les adjectifs"
          "trvl":
            set gGameName to "Les Voyages"
          "tphr":
            set gGameName to "Expressions utiles pour voyager"
          "mphr":
            set gGameName to "Autres expressions utiles"
          "all":
            set gGameName to "Tout!"
          "allw":
            set gGameName to "Tous les mots"
        end case
      "i":
        case gWhichGame of
          "colr":
            set gGameName to "Colori"
          "tran":
            set gGameName to "Trasportazione"
          "clth":
            set gGameName to "Abbigliamento"
          "rltv":
            set gGameName to "Persone"
          "stor":
            set gGameName to "Negozi"
          "buil":
            set gGameName to "Edifici"
          "body":
            set gGameName to "Il corpo"
          "spor":
            set gGameName to "Sport e Passatempi"
          "occp":
            set gGameName to "Occupazioni"
          "numb":
            set gGameName to "Numeri"
          "schl":
            set gGameName to "Scuola"
          "dirc":
            set gGameName to "Indicazioni"
          "bath":
            set gGameName to "La Stanza  da Bagno"
          "kitc":
            set gGameName to "La Cucina"
          "time":
            set gGameName to "Orario"
          "geog":
            set gGameName to "Geografia"
          "city":
            set gGameName to "La Città"
          "hous":
            set gGameName to "La Casa"
          "furn":
            set gGameName to "Mobili"
          "weat":
            set gGameName to "Tempo"
          "conj":
            set gGameName to "Varie"
          "anml":
            set gGameName to "Animali"
          "food":
            set gGameName to "Cibi"
          "advb":
            set gGameName to "Avverbi"
          "verb":
            set gGameName to "Verbi"
          "adjv":
            set gGameName to "Aggettivi"
          "trvl":
            set gGameName to "Viaggiatore"
          "tphr":
            set gGameName to "Frasi per il viaggiatore"
          "mphr":
            set gGameName to "Altre Frasi Utili"
          "all":
            set gGameName to "Tutto!"
          "allw":
            set gGameName to "Tutte parole"
        end case
    end case
  end if
end

on TrackChangeGame
  global gWhichGame, gTotalAttempts, gNumCorrect, gNumWrong, gTimeBegan, gLangSelect, gLangDirect
  if gLangDirect = 1 then
    set timeTitle to "Time began"
    set timeEndTitle to "Time ended"
    set attemptTitle to "Number of problems attempted"
    set totCorr to "Total correct"
    set totInCorr to "Total incorrect"
    set perCorr to "Percent correct"
  else
    case gLangSelect of
      "g":
        set timeTitle to "Anfangszeit"
        set timeEndTitle to "Schlußzeit"
        set attemptTitle to "Anzahl versuchter Problemlösungen"
        set totCorr to "Gesamtzahl richtig"
        set totInCorr to "Gesamtzahl falsch"
        set perCorr to "Prozentzahl richtig"
      "s":
        set timeTitle to "La hora comezó"
        set timeEndTitle to "La hora terminó"
        set attemptTitle to "Número de problemas intentados"
        set totCorr to "Total correcto"
        set totInCorr to "Total incorrecto"
        set perCorr to "Porcentaje correcto"
      "f":
        set timeTitle to "Heure du début"
        set timeEndTitle to "Heure de la fin"
        set attemptTitle to "Nombre de problèmes tentés"
        set totCorr to "Total des réponses correctes"
        set totInCorr to "Total des réponses incorrectes"
        set perCorr to "Pourcentage des réponses correctes"
      "i":
        set timeTitle to "Orario d'inizio"
        set timeEndTitle to "Orario di conclusione"
        set attemptTitle to "Numero di problemi tentati"
        set totCorr to "Totale corretto"
        set totInCorr to "Totale sbagliato"
        set perCorr to "Percentuale corretta"
    end case
  end if
  if gTotalAttempts > 0 then
    set the floatPrecision to 1
    set X to integer(float(gNumCorrect) / float(gTotalAttempts) * 100.0)
    put RETURN & "----------------------------------------------------------------" after field "trackingfield"
    put RETURN & timeTitle & ":" && gTimeBegan after field "trackingfield"
    put RETURN & timeEndTitle & ":" && the short time after field "trackingfield"
    put RETURN & attemptTitle & ":" && gTotalAttempts after field "trackingfield"
    put RETURN & totCorr & ":" && gNumCorrect after field "trackingfield"
    put RETURN & totInCorr & ":" && gNumWrong after field "trackingfield"
    put RETURN & perCorr & ":" && X & "%" after field "trackingfield"
  end if
end

on TrackAnswer wasItRight, rightAnswer, yourAnswer
  global gTotalAttempts, gNumCorrect, gNumWrong, gLevel, gAnswer, gGameName, gQuestion, gLangSelect, gLangDirect
  if gLangDirect = 1 then
    set catTitle to "Category"
  else
    case gLangSelect of
      "g":
        set catTitle to "Kategorie"
      "s":
        set catTitle to "Categoría"
      "f":
        set catTitle to "Catégorie"
      "i":
        set catTitle to "Categoria"
    end case
  end if
  set gTotalAttempts to gTotalAttempts + 1
  case wasItRight of
    "1":
      put RETURN & catTitle & ": " & gGameName & "/" & gQuestion & "/" & rightAnswer after field "trackingfield"
      set gNumCorrect to gNumCorrect + 1
    "0":
      put RETURN & catTitle & ": " & gGameName & "/" & gQuestion & "/" & rightAnswer & "/" & yourAnswer & " (*)" after field "trackingfield"
      set gNumWrong to gNumWrong + 1
  end case
end

on FinishTracking
  global gLangSelect, gLangDirect
  if gLangDirect = 1 then
    set wrongResp to "*indicates an incorrect response."
  else
    case gLangSelect of
      "g":
        set wrongResp to "*zeigt eine falsche Antwort an."
      "s":
        set wrongResp to "*indica una respuesta incorrecta."
      "f":
        set wrongResp to "*indique une réponse incorrecte."
      "i":
        set wrongResp to "*Indica una risposta sbagliata."
    end case
  end if
  put RETURN & "---------------------------------" after field "trackingfield"
  put RETURN && wrongResp after field "trackingfield"
  put RETURN & "---------------------------------" after field "trackingfield"
end

on ClearTrackingFields
  put EMPTY into field "trackingfield"
end

on printTrackingField
  global gMachineType
  cursor(4)
  set gMachineType to the machineType
  if gMachineType = 256 then
    set printingFont to "Courier"
    set printingSize to 12
    openXLib("pmatic.dll")
  else
    set printingFont to "Courier"
    set printingSize to 12
  end if
  set printer to PrintOMatic(mnew)
  if not objectp(printer) then
    alert("There is no currently selected printer. Printing features are disabled.")
  else
    printer(mRegister, "PMAT130-209-01293")
    printer(mSetMargins, 60, 60, 60, 60)
    set w to printer(mGetPageWidth)
    set h to printer(mGetPageHeight)
    printer(mSetTextFont, printingFont)
    printer(mSetTextSize, printingSize)
    printer(mSetTextStyle, "normal")
    printer(mNewPage)
    printer(mTextBox, 0, 0, w, h, 0)
    set textString to field "Trackingfield"
    printer(mSetText, textString, 1)
    printer(mPrint)
    printer(mdispose)
    if gMachineType = 256 then
      closeXLib("pmatic.dll")
    end if
  end if
  cursor(-1)
end

on SaveTrackingField
  cursor(4)
  if the machineType = 256 then
    set FileLineDelimiter to RETURN & numToChar(10)
  else
    set FileLineDelimiter to RETURN
  end if
  if objectp(myFile) then
    set myFile to 0
  end if
  set theFile to the text of field "Trackingfield"
  set myFile to new(xtra("FileIO"))
  if the moviePath = EMPTY then
    alert("An uncontrolable error occured while saving, please exit.")
  else
    set FilePath to displaySave(myFile, "Choose a place to save:", "BEAR.txt")
    createFile(myFile, FilePath)
    openFile(myFile, FilePath, 0)
    delete(myFile)
    createFile(myFile, FilePath)
    openFile(myFile, FilePath, 0)
    setPosition(myFile, 0)
    setFinderInfo(myFile, "TEXT ttxt")
    repeat with X = 1 to the number of lines in theFile
      writeString(myFile, line X of theFile & FileLineDelimiter)
    end repeat
  end if
  closeFile(myFile)
  set myFile to 0
  cursor(-1)
end
